'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               Soundscape GLSLf                           |
'|                          BassBox OpenGL plugin                           |
'|                         FreeBasic Source Version                         |
'|                                                                          |
'|                              Version 1.00                                |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                           Author Charles Pegge                           |
'|                                                                          |
'|                            copyright(c) 2008                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 02-01-2008 (MM-DD-YYYY)            |
'|                        Last revised : 02-06-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
''

'  BUILDING THE DLL
'  ================
'
'  STEP 1
'  ------
'  Actitivate the FreeBasic console
'
'  STEP 2
'  ------
'  FreeBasic v .18.3 does not come with a libgdiplus.a
'  This must be generated from the included def file using dlltool.
'  Once you have it. There is no need to do this step again, and the lib file 
'  can be tranferred to the FreeBasic lib folder with the others.
'
'  The command goes like this (Adjusting to your own directory path)
'
'  C:\cevp\projects\freebasic\183b\bin\win32\dlltool -k -d gdiplus.dll.def -l libgdiplus.dll.a
'
'  STEP 3
'  ------
'  Compile at the console like this:
'
'  fbc -dylib SoundscapGLSLf.bas
'
'  This will produce: SoundscapeGLSLf.dll
'
'
'
'
'  DEPENDENCIES:
'  -------------
'  Version of BassBox that supports Plugin DLLs with decorated function name "BBProc@4"
'  Shader folder containing shader source code: ShaderA.txt
'  Texture folder containing "Venus.jpg"
'  Windows XP or Vista (with GDIPLUS.DLL and OPENGL32.DLL)
'
'
'
'
'  TWO MODIFICATIONS TO BASSBOX V1.25
'  ----------------------------------
'  (CompilerPowerBasic 8.03)
'  
'
'          IF hLibModule THEN
'             hProc = GetProcAddress(hLibModule, "BBProc")
'             IF hProc=0 THEN hProc = GetProcAddress(hLibModule, "BBProc@4") ' NEW LINE INSERTED
' .....
'             IF hLib THEN
'                hProc = GetProcAddress(hLib, "BBProc")
'                IF hProc=0 THEN hProc = GetProcAddress(hLib, "BBProc@4") ' NEW LINE INSERTED




#if 0




'-----------------------------------------

    #define BBP_NO_IOFILE   1
    #define BBP_NO_REGISTRY 1
    #define BBP_NO_GLFONT   1

'-----------------------------------------
#define proc           any ptr
#define HDC            uinteger
#define HWND           uinteger
#define HGLRC          uinteger
#define HINSTANCE      any pointer
#define LARGE_INTEGER  longint

' Key State Masks for Mouse Messages
#define MK_LBUTTON                     &h0001
#define MK_RBUTTON                     &h0002
#define MK_SHIFT                       &h0004
#define MK_CONTROL                     &h0008
#define MK_MBUTTON                     &h0010
#define MK_XBUTTON1                    &h0020
#define MK_XBUTTON2                    &h0040

#define WM_MOUSEMOVE                   &h200
#define WM_LBUTTONDOWN                 &h201
#define WM_LBUTTONUP                   &h202
#define WM_LBUTTONDBLCLK               &h203
#define WM_RBUTTONDOWN                 &h204
#define WM_RBUTTONUP                   &h205
#define WM_RBUTTONDBLCLK               &h206
#define WM_MBUTTONDOWN                 &h207
#define WM_MBUTTONUP                   &h208
#define WM_MBUTTONDBLCLK               &h209
#define WM_MOUSEWHEEL                  &h20A
#define WM_XBUTTONDOWN                 &h20B
#define WM_XBUTTONUP                   &h20C
#define WM_XBUTTONDBLCLK               &h20D

' Keyboard messages
#define WM_KEYDOWN                     &h100
#define WM_KEYUP                       &h101
#define WM_CHAR                        &h102
#define WM_DEADCHAR                    &h103
#define WM_SYSKEYDOWN                  &h104
#define WM_SYSKEYUP                    &h105
#define WM_SYSCHAR                     &h106
#define WM_SYSDEADCHAR                 &h107

'-----------------------------------------

TYPE RECT
    Left AS LONG
    Top AS LONG
    Right AS LONG
    Bottom AS LONG
END TYPE


DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (BYVAL lpLibFileName AS ZSTRING PTR) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS UINTEGER) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS UINTEGER, BYVAL lpProcName AS ZSTRING PTR) AS LONG
DECLARE FUNCTION QueryPerformanceCounter LIB "KERNEL32.DLL" ALIAS "QueryPerformanceCounter" (BYVAL lpPerformanceCount AS LONGINT PTR) AS LONG
DECLARE FUNCTION QueryPerformanceFrequency LIB "KERNEL32.DLL" ALIAS "QueryPerformanceFrequency" (BYVAL lpFrequency AS LONGINT PTR) AS LONG
DECLARE FUNCTION wglGetProcAddress LIB "OPENGL32.DLL" ALIAS "wglGetProcAddress" (BYVAL lpszProc AS ZSTRING PTR) AS UINTEGER

DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS UINTEGER, BYVAL lpRect AS RECT PTR) AS LONG
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS UINTEGER, BYVAL hglrc AS UINTEGER) AS LONG
'DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS UINTEGER
'DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS UINTEGER) AS LONG

'-----------------------------------------
#endif



#include "WINDOWS.BI"
#include "WIN\GDIPLUS.BI"
#include "GL\GL.BI"
#include "GL\GLU.BI"
#include "GL\GLEXT.BI"

'#INCLUDE "Include\BBPlugin.bi"


#define BBP_RENDER     1               '// Render the scene.
#define BBP_CREATE     2               '// Retrieve Title, Name, Version, Render mode.
#define BBP_INIT       3               '// Init the OpenGL.
#define BBP_SIZE       4               '// The size of the control has changed.
#define BBP_KEYBOARD   5               '// All keyborad message.
#define BBP_MOUSE      6               '// All mouse messages.
#define BBP_DESTROY    7               '// Free Up resources.

#define BBP_GDIPLUS    0                '// GDImage GDIPLUS compatible mode.
#define BBP_OPENGL     1                '// OpenGL mode.
#define BBP_DIRECTX    2                '// DirectX mode (for future extension).

#define BBP_SUCCESS    0
#define BBP_ERROR      -1

#define BBP_PLUGIN_FOLDER "BBplugin\"

TYPE BBPLUGIN FIELD=1           '// 256 bytes
    Msg          AS LONG        '// The plugin's message (see above constant list).
    ParentWindow AS LONG        '// The parent window handle.
    DC           AS LONG        '// The parent window DC (while in play mode).
    RC           AS LONG        '// The parent OpenGL RC (while in play mode).
    Lpeak        AS USHORT      '// The left audio channel peak value (while in play mode).
    Rpeak        AS USHORT      '// The right audio channel peak value (while in play mode).
    Title        AS ZSTRING*32  '// Plugin's name or title.
    Author       AS ZSTRING*64  '// Plugin's author name.
    Version      AS UINTEGER    '// LOWRD major, HIWRD minor.
    RenderTo     AS LONG        '// BBP_GDIPLUS, BBP_OPENGL, BBP_DIRECTX.
    BackARGB     AS LONG        '// Default ARGB color background.
    FFTdata      AS UINTEGER    '// UINT pointer to the FFT() AS SINGLE array.
    FFTsize      AS SHORT      '// Size of the FFT array.

    WinMsg       AS LONG        '// True Windows message.
    wParam       AS LONG        '// wParam 
    lParam       AS LONG        '// lParam
    
    WIMdata      AS UINTEGER    '// UINT pointer to the wave MM_WIM_DATA.
    MediaLength  AS UINTEGER    '// Media length.
    MediaPos     AS UINTEGER    '// Media pos.

    Reserved     AS ZSTRING*98  '// Reserved for future extension.
END TYPE


'/* ErrorCode */
' GL_NO_ERROR                       0
' GL_INVALID_ENUM                   &H0500
' GL_INVALID_VALUE                  &H0501
' GL_INVALID_OPERATION              &H0502
' GL_STACK_OVERFLOW                 &H0503
' GL_STACK_UNDERFLOW                &H0504
' GL_OUT_OF_MEMORY                  &H0505

'-----------------------------------------


    dim shared as long FREEIMAGE
    dim shared as long GLSL
    dim shared as long hstatus

    dim shared as proc glCreateShader,glShaderSource,glCompileShader 'glGetObjectParameteriv
    dim shared as proc glGetShaderiv,glGetInfoLog,glAttachShader,glDetachShader,glDeleteShader,glLinkProgram
    dim shared as proc glCreateProgram,glDeleteProgram,glGetProgramiv,glUseProgram
    dim shared as proc glGetUniformLocation,glGetUniformfv,glGetUniformiv
    dim shared as proc glUniform1f,glUniform2f,glUniform3f,glUniform4f
    dim shared  as proc glActiveTexture,glMultiTexCoord2f,glMultiTexCoord2fv

sub gAddress(byval zs as zstring ptr, byref p as proc)
    p=wglGetProcAddress(zS)
    if p=0 then GLSL=0
end sub


sub BindGLSL()
    dim a as long
    GLSL=-1
    ' Multitexturing
    gAddress "glActiveTextureARB",glActiveTexture
    gAddress "glMultiTexCoord2fARB",glMultiTexCoord2f
    gAddress "glMultiTexCoord2fvARB",glMultiTexCoord2fv
    '
    gAddress "glCreateShader",glCreateShader
    gAddress "glShaderSourceARB",glShaderSource   ' ARB
    gAddress "glCompileShaderARB",glCompileShader ' ARB
    gAddress "glGetInfoLogARB",glGetInfoLog       ' ARB only
    'glGetObjectParameteriv ??
    gAddress "glGetShaderiv",glGetShaderiv
    gAddress "glAttachShader",glAttachShader
    gAddress "glDetachShader",glDetachShader
    gAddress "glDeleteShader",glDeleteShader
    gAddress "glLinkProgram",glLinkProgram
    gAddress "glCreateProgram",glCreateProgram
    gAddress "glDeleteProgram",glDeleteProgram
    gAddress "glGetProgramiv",glGetProgramiv
    gAddress "glUseProgram",glUseProgram
    '
    gAddress "glGetUniformLocation",glGetUniformLocation
    gAddress "glGetUniformfv",glGetUniformfv
    gAddress "glGetUniformiv",glGetUniformiv
    gAddress "glUniform1f",glUniform1f
    gAddress "glUniform2f",glUniform2f
    gAddress "glUniform3f",glUniform3f
    gAddress "glUniform4f",glUniform4f
end sub


FUNCTION CreateShaderProg(ShaderFile AS STRING, byref VObj AS LONG, byref FObj AS LONG) AS LONG
    ' http://www.opengl.org/sdk/docs/tutorials/ClockworkCoders/loading.php
'    
    IF GLSL=0 THEN EXIT FUNCTION
    dim as long e,i,j,k,m,n
    dim as string fi,sh,InfoLog,sbuf
    dim as string FragmentShaderSource
    dim as string VertexShaderSource
    dim as long VertexShaderObject, FragmentShaderObject
    dim as any pointer p
    dim as string*2 CRLF =chr$(13)+chr$(10)
    '
    fi=DIR$(ShaderFile): IF LEN(fi)=0 THEN EXIT FUNCTION
    i=FREEFILE:OPEN ShaderFile FOR BINARY AS i
    sh=string$(lof(i),chr$(0))
    GET #i, 1,sh
    CLOSE(i)
    IF LEN(sh)=0 THEN EXIT FUNCTION
    i=INSTR(sh,"[VERTEX SHADER]")
    IF i THEN
        j=INSTR(i,sh,"[END VERTEX SHADER]")
        IF j=0 THEN j=LEN(sh)+1
        i=i+15:VertexShaderSource=MID$(sh,i,j-i)
    END IF
    i=INSTR(sh,"[FRAGMENT SHADER]")
    IF i THEN
        j=INSTR(i,sh,"[END FRAGMENT SHADER]")
        IF j=0 THEN j=LEN(sh)+1
        i=i+17:FragmentShaderSource=MID$(sh,i,j-i)
    END IF
    '
    ' vertexShaderObject = glCreateShader(GL_VERTEX_SHADER);
    asm  push GL_VERTEX_SHADER
    asm  call [glCreateShader]
    asm  mov [VertexShaderObject],eax
    'fragmentShaderObject = glCreateShader(GL_FRAGMENT_SHADER);
    asm  push GL_FRAGMENT_SHADER
    asm  call [glCreateShader]
    asm  mov [FragmentShaderObject],eax
    'glShaderSourceARB(vertexShaderObject, 1, &VertexShaderSource, &vlength);
    j=LEN(VertexShaderSource)
    p=VARPTR(j)
    asm  push [p]
    p=VARPTR(VertexShaderSource)
    asm  push eax
    asm  push 1
    asm  push [vertexShaderObject]
    asm  call [glShaderSource]

    ' glShaderSourceARB(fragmentShaderObject, 1, &FragmentShaderSource, &flength);
    j=LEN(FragmentShaderSource)
    p=VARPTR(j)
    asm  push [p]
    p=VARPTR(FragmentShaderSource)
    asm  push [p]
    asm  push 1
    asm  push [FragmentShaderObject]
    asm  call [glShaderSource]

    ' glCompileShaderARB(VertexShaderObject);
    asm  push [VertexShaderObject]
    asm  call [glCompileShader]

    ' glCompileShaderARB(fragmentShaderObject);
    asm  push [FragmentShaderObject]
    asm  call [glCompileShader]

    ' glGetObjectParameteriv(ShaderObject, GL_COMPILE_STATUS, &compiled); OBSOLETE?
    'p=varptr(j)
    'asm  push [p]
    'asm  push GL_COMPILE_STATUS
    'asm  push [VertexShaderObject]
    'asm  call [glGetObjectParameteriv]
    ' if (compiled) { /* yes it compiledasm  */ }

    'glGetShaderiv(ShaderObject, GL_INFO_LOG_LENGTH , &blen);
    p=VARPTR(j)
    asm  push [p]
    asm  push GL_INFO_LOG_LENGTH
    asm  push [VertexShaderObject]
    asm  call [glGetShaderiv]
    IF j>1 THEN
        'glGetInfoLogARB(ShaderObject, blen, &slen, compiler_log);
        InfoLog=string$(1024,chr$(0))
        sbuf=infolog
        p=STRPTR(InfoLog)
        asm  push eax
        p=VARPTR(j)
        asm  push [p]
        asm  push 1024
        asm  push [VertexShaderObject]
        asm  call [glGetInfoLog]
        'MSGBOX InfoLog ' compiler errors
        InfoLog=RTRIM$(InfoLog) ' nulls?
        'REPLACE $LF WITH $CRLF IN Infolog
        i=1:m=1
        do
            if i>1024 then exit do
            k=asc(Infolog,i)
            if k=0 then m+=1: exit do
            if k=10 then mid$(sbuf,m)=chr$(13)+chr$(10):m+=2
            if k>10 then mid$(sbuf,m)=chr$(k): m+=1
            i+=1
        loop
        k=i
        i=FREEFILE
        OPEN BBP_PLUGIN_FOLDER+"shader\shader_errors.txt" FOR OUTPUT AS i
        PRINT #i,Shaderfile+CRLF+TIME$+"  "+DATE$+CRLF+CRLF+left$(sbuf,m)
        CLOSE i
        EXIT FUNCTION
    END IF

     'Linking:

    'ProgramObject = glCreateProgram();
    asm  call [glCreateProgram]
    asm  mov [j],eax

    'glAttachShader(ProgramObject, vertexShaderObject);
    asm  push [VertexShaderObject]
    asm  push [j]
    asm  call [glAttachShader]

    ' glAttachShader(ProgramObject, fragmentShaderObject);
    asm  push [FragmentShaderObject]
    asm  push [j]
    asm  call [glAttachShader]

    ' glLinkProgram(ProgramObject);
    asm  push [j]
    asm  call [glLinkProgram]

    ' glGetProgramiv(ProgramObject, GL_LINK_STATUS, &linked);
    p=VARPTR(k)
    asm  push [p]
    asm  push GL_LINK_STATUS
    asm  push [j]
    asm  call [glGetProgramiv]
    Vobj=VertexShaderObject
    fObj=FragmentShaderObject
    FUNCTION=j ' ProgramObject
END FUNCTION


' PERFORMANCE

' ========================================================================================
SUB TimeStamp(byref tick AS longint) ' CPU Clock count

  '---------------------------'
  '                           ' approx because it is not a serialised instruction
  '                           ' it may execute before or after other instructions
  '                           ' in the pipeline.
  asm  mov ebx,[tick]            ' var address where count is to be stored.
  asm  rdtsc ' db  &h0f,&h31     ' RDTSC read time-stamp counter into edx:eax hi lo.
  asm  mov [ebx],eax             ' save low order 4 bytes.
  asm  mov [ebx+4],edx           ' save high order 4 bytes.
  '---------------------------'

END SUB
' ========================================================================================




' IMAGING
' ========================================================================================
' USING GDIplus
' ========================================================================================
#if 0
' enum RotateFlipType

#define RotateNoneFlipNone  0
#define Rotate90FlipNone    1
#define Rotate180FlipNone   2
#define Rotate270FlipNone   3

#define RotateNoneFlipX     4
#define Rotate90FlipX       5
#define Rotate180FlipX      6
#define Rotate270FlipX      7

#define RotateNoneFlipY     Rotate180FlipX
#define Rotate90FlipY       Rotate270FlipX
#define Rotate180FlipY      RotateNoneFlipX
#define Rotate270FlipY      Rotate90FlipX

#define RotateNoneFlipXY    Rotate180FlipNone
#define Rotate90FlipXY      Rotate270FlipNone
#define Rotate180FlipXY     RotateNoneFlipNone
#define Rotate270FlipXY     Rotate90FlipNone

type GdiplusStartupInput
	GdiplusVersion as uinteger       'UINT32
	DebugEventCallback as proc       ' DebugEventProc
	SuppressBackgroundThread as long ' BOOL
	SuppressExternalCodecs as long   ' BOOL
end type

dim shared GdiplusStartup as function( _
    byval Token as uinteger ptr _
  , byval gpInput as GdiplusStartupInput ptr _
  , byval gpOutput as uinteger ptr _
  ) as long

dim shared GdiplusShutdown as sub ( _
    byval Token as uinteger ptr _
  )

dim  shared GdipLoadImageFromFile  as function ( _
    BYVAL pFilename AS STRING _                         ' *GDIPCONST WCHAR
  , BYVAL pImage AS UINTEGER PTR _                      ' *GpImage
    ) AS LONG                                           ' GpStatus <enum>

dim shared  GdipGetImageThumbnail as function ( _
    BYVAL pImage AS UINTEGER _                          ' *GpImage
  , BYVAL thumbWidth AS UINTEGER _                      ' UINT
  , BYVAL thumbHeight AS UINTEGER _                     ' UINT
  , BYVAL thumbImage AS UINTEGER PTR _                  ' **GpImage
  , BYVAL pcallback AS UINTEGER _                       ' GetThumbnailImageAbort
  , BYVAL callbackData AS UINTEGER _                    ' *void
    ) AS LONG                                           ' GpStatus <enum>

dim shared GdipImageRotateFlip as function ( _
    BYVAL pImage AS UINTEGER _                          ' *GpImage
  , BYVAL rfType AS LONG _                              ' RotateFlipType <enum>
    ) AS LONG                                           ' GpStatus <enum>

dim shared GdipBitmapGetPixel as function  ( _
    BYVAL nBitmap AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL Colr AS LONG PTR) AS LONG

dim shared GdipDisposeImage as function ( _
    BYVAL nImage AS LONG) AS LONG


DIM SHARED AS LONG GDIPLUS


SUB bindGDIPLUS
    dim as HINSTANCE a
    a=DyLibLoad("GDIplus.dll")
    if a=0 then GDIPLUS=0: exit sub ' not available
    GDIPLUS=-1
    GdiplusStartup=DyLibSymbol(a,"GdiplusStartup"): if GdiplusStartup=0 then GDIPLUS=0
    GdiplusShutdown=DyLibSymbol(a,"GdiplusShutdown"): if GdiplusShutdown=0 then GDIPLUS=0
    '
    GdipLoadImageFromFile=DyLibSymbol(a,"GdipLoadImageFromFile"): if GdipLoadImageFromFile=0 then GDIPLUS=0
    GdipImageRotateFlip=DyLibSymbol(a,"GdipImageRotateFlip"): if GdipImageRotateFlip=0 then GDIPLUS=0
    GdipBitmapGetPixel=DyLibSymbol(a,"GdipBitmapGetPixel"): if GdipBitmapGetPixel=0 then GDIPLUS=0
    GdipDisposeImage=DyLibSymbol(a,"GdipDisposeImage"): if GdipDisposeImage=0 then GDIPLUS=0
    'DylibFree(a) ' on destroy 
END SUB

#endif


DIM SHARED AS STRING pixmap(128)
DIM SHARED AS LONG texture(128)

SUB MakeTex(byval texNum AS LONG ,byval pa as ubyte ptr , byval xSize AS LONG, byval ySize AS LONG )
    glBindTexture GL_TEXTURE_2D, texNum
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR '_MIPMAP_LINEAR ' _MIPMAP_LINEAR
    glTexImage2D GL_TEXTURE_2D, 0, 4, xSize, ySize, 0, GL_RGBA, GL_UNSIGNED_BYTE, pa
END SUB


'enum Status
'  Ok = 0
'  GenericError = 1
'  InvalidParameter = 2
'  OutOfMemory = 3
'  ObjectBusy = 4
'  InsufficientBuffer = 5
'  NotImplemented = 6
'  Win32Error = 7
'  WrongState = 8
'  Aborted = 9
'  FileNotFound = 10
'  ValueOverflow = 11
'  AccessDenied = 12
'  UnknownImageFormat = 13
'  FontFamilyNotFound = 14
'  FontStyleNotFound = 15
'  NotTrueTypeFont = 16
'  UnsupportedGdiplusVersion = 17
'  GdiplusNotInitialized = 18
'  PropertyNotFound = 19
'  PropertyNotSupported = 20
'End enum
 
SUB TexImageGDIP (img AS STRING, byval ref AS LONG, byref p AS LONG )
    'Using gdiplus
    'dim as uinteger pBitmap,pThumb
    'if GDIPLUS=0 then exit sub ' not available
    Dim As GDIPLUS.GpImage ptr pBitMap, pThumb
    Dim as GDIPLUS.gpStatus hstatus
    '
    '
    pixmap(ref)=string$(4*256*256,chr$(0)) ' GLOBAL pixmap()
    hstatus=GDIPLUS.GdipLoadImageFromFile(wstr(img), @pBitmap)
    'if pBitMap=0 then GDIPLUS=-2:exit sub
    hstatus=GDIPLUS.GdipGetImageThumbnail ( pBitMap, 256, 256, @pThumb, 0, 0 )
    'if pThumb=0 then gdiplus=-3:exit sub
    GDIPLUS.GdipImageRotateFlip(pThumb,GDIPLUS.RotateNoneFlipY) 'invert
    dim AS byte PTR pp
    dim as long ptr w
    pp=STRPTR(pixmap(ref))
    w=cast(long ptr,pp)
    p=cast(long,pp) ' return string pointer
    dim as long x,y
    FOR y=0 TO 255
        FOR x=0 TO 255
            GDIPLUS.GdipBitmapGetPixel (pThumb, x, y, w)
            ' RED BLUE SWAP FOR OPENGL
            asm  mov edx,[w]
            asm  mov al,[edx]
            asm  xchg al,[edx+2]
            asm  mov [edx],al
            'asm  mov byte ptr [edx+3],255 ' with FREEIMAGE we must set jpeg alpha
            asm  add dword ptr [w],4
        NEXT
    NEXT
    GDIPLUS.GdipDisposeImage (pBitmap)
    GDIPLUS.GdipDisposeImage (pThumb)
    MakeTex (Texture(ref),pp,256,256)
END SUB


' ========================================================================================
' DLL_API FIBITMAP *DLL_CALLCONV FreeImage_Load(FREE_IMAGE_FORMAT fif, const char *filename,
' int flags FI_DEFAULT(0));
' ========================================================================================
DECLARE FUNCTION FreeImage_Load _
   LIB "FreeImage.dll" ALIAS "FreeImage_Load" ( _
   BYVAL AS LONG, _                       ' FREE_IMAGE_FORMAT fif
   BYVAL AS ZSTRING PTR, _                ' const char *filename
   ByVal flags As Integer = 0 _           ' int flags FI_DEFAULT(0)
   ) AS UINTEGER                          ' FIBITMAP *
' ========================================================================================


' ========================================================================================
' DLL_API FIBITMAP *DLL_CALLCONV FreeImage_Rescale(FIBITMAP *dib, int dst_width,
' int dst_height, FREE_IMAGE_FILTER filter);
' ========================================================================================
DECLARE FUNCTION FreeImage_Rescale _
   LIB "FreeImage.dll" ALIAS "FreeImage_Rescale" ( _
   BYVAL AS UINTEGER, _                      ' FIBITMAP *dib
   BYVAL AS LONG, _                       ' int dst_width
   BYVAL AS LONG, _                       ' int dst_height
   BYVAL AS LONG _                        ' FREE_IMAGE_FILTER filter
   ) AS UINTEGER                       ' FIBITMAP *
' ========================================================================================

' ========================================================================================
' DLL_API BOOL DLL_CALLCONV FreeImage_FlipVertical(FIBITMAP *dib);
' ========================================================================================
DECLARE FUNCTION FreeImage_FlipVertical _
   LIB "FreeImage.dll" ALIAS "FreeImage_FlipVertical" ( _
   BYVAL AS UINTEGER _                    ' FIBITMAP *dib
   ) AS LONG                           ' BOOL
' ========================================================================================


' ========================================================================================
' DLL_API BOOL DLL_CALLCONV FreeImage_GetPixelColor(FIBITMAP *dib, unsigned x, unsigned y,
' RGBQUAD *value);
' ========================================================================================
DECLARE FUNCTION FreeImage_GetPixelColor _
   LIB "FreeImage.dll" ALIAS "FreeImage_GetPixelColor" ( _
   BYVAL AS UINTEGER, _                ' FIBITMAP *dib
   BYVAL AS UINTEGER, _                ' unsigned x
   BYVAL AS UINTEGER, _                ' unsigned y
   BYVAL AS LONG PTR _                 ' RGBQUAD *value
   ) AS LONG                           ' BOOL
' ========================================================================================


' ========================================================================================
' DLL_API void DLL_CALLCONV FreeImage_Unload(FIBITMAP *dib);
' ========================================================================================
DECLARE SUB FreeImage_Unload _
   LIB "FreeImage.dll" ALIAS "FreeImage_Unload" ( _
   BYVAL AS UINTEGER _                       ' FIBITMAP *dib
   )                                   ' void
' ========================================================================================

SUB TexImageFI (img AS STRING, byval ref AS LONG, byref b AS LONG )
    dim as long pBitmap,pThumb
    dim as ubyte ptr p
    pixmap(ref)=string$(4*256*256,chr$(0)) ' GLOBAL pixmap()
    dim as zstring*128 zFileName
    zFileName=img
    dim as long h,t
    h=FreeImage_Load (2,zFileName,0) ' -1 unkn 2 jpeg 13 png
    if h=0 then exit sub
    t=FreeImage_Rescale (h,256,256,0)
    if t=0 then exit sub
    ''FreeImage_FlipVertical t ' No need to flip with FreeImage
    dim as long ptr w
    p=STRPTR(pixmap(ref))
    w=Cast(long ptr,p)
    b=cast(long,w)
    dim as long x,y
    FOR y=0 TO 255
        FOR x=0 TO 255
            FreeImage_GetPixelColor t,x,y,w
            '*w=&hffffffff
            ' RED BLUE SWAP FOR OPENGL
            asm  mov edx,[w]
            asm  mov al,[edx]
            asm  xchg al,[edx+2]
            asm  mov [edx],al
            asm  mov byte ptr [edx+3],255 ' with FREEIMAGE we must set jpeg alpha
            asm  add dword ptr [w],4
        NEXT
    NEXT
    FreeImage_Unload h
    FreeImage_Unload t
    MakeTex Texture(ref),p,256,256
END SUB


'---------------------------------------
' GEOMETRICA extracts
'---------------------------------------
TYPE vector3dv
    x AS DOUBLE
    y AS DOUBLE
    z AS DOUBLE
END TYPE

TYPE vector3fv
    x AS SINGLE
    y AS SINGLE
    z AS SINGLE
END TYPE

TYPE vector4fv
    r AS SINGLE
    g AS SINGLE
    b AS SINGLE
    a AS SINGLE
END TYPE

SUB planet(byval sz AS SINGLE,byval ds AS SINGLE)
  dim as integer i,j
  dim as single pi=ATN(1)*4
  dim as single dtr=pi/180
  dim as single a,x,y1,y2,z,v1,v2
  dim as integer st
  st=INT(ds/(50*sz))*10 'reduce triangle count with distance/size
  if st>5 then st=5
  if st<1 then st=1
  glPushMatrix
  glScalef sz,sz,sz
  FOR j=0 TO 180-st STEP st
   y1=COS(j*dtr):y2=COS((j+st)*dtr)
   v1=SQR(1-(y1*y1)): v2=SQR(1-(y2*y2))
   glbegin GL_TRIANGLE_STRIP
   FOR i=0 TO 360 STEP st ' use 180 for front half only
    a=i*dtr:x=COS(a)*v1:z=SIN(a)*v1
    glTexCoord2f 1-i/360, ((1-j)/180)
    glNormal3f  x+x, y1+y1, z+z
    glVertex3f  x, y1, z
    x=COS(a)*v2:z=SIN(a)*v2
    glTexCoord2f 1-i/360, ((1-(j+st))/180)
    glNormal3f  x+x, y2+y2, z+z
    glVertex3f  x, y2, z
   NEXT i
   glEnd
  NEXT j
  glPopMatrix
 END SUB

'---------------------------------------
' END GEOMETRICA
'---------------------------------------



#define MAXOB                          100

'SCENE ELEMENTS
DECLARE SUB main_lighting(b AS SINGLE,d AS SINGLE, s AS SINGLE, a AS SINGLE, m AS SINGLE)

'    dim shared  as long texture(128)
'    dim shared string pixmap(32)





sub generate_textures
         glGenTextures 32, @texture(0)
         '
         'IF GLSL THEN
         '    asm  push GL_TEXTURE0
         '    asm  call [glActiveTexture]
         'END IF
         '
         dim as ubyte pix(&h1000) ' upto 32*32 * (32 bit pixel)
         dim as ubyte ptr b,p
         dim as long i,j,k
         'bindGDIPLUS
         'if GDIPLUS then
             'dim as GdiplusStartupInput gpi
             'dim as uinteger gpToken
	     'gpi.GdiplusVersion =1
             'hstatus=GdiplusStartup (@gpToken,@gpi,null)
             '
             TexImageGDIP (BBP_PLUGIN_FOLDER + "Texture\venus.jpg",1,i)
             '
             'GdiplusShutdown (@gpToken)
         'end if
         'if GDIPLUS<>-1 then FREEIMAGE=-1
         if FREEIMAGE then
             TexImageFI (BBP_PLUGIN_FOLDER + "Texture\venus.jpg",1,i)
         end if
         b=@pix(0)
         p=b+20 ' (1*4+1)*4
         ' set single pixel at y=1:x=1
         *p=255: p+=1 ' red
         *p=255: p+=1 ' green
         *p=255: p+=1 ' blue
         *p=255: p+=1 ' alpha
         MakeTex (Texture(2), b, 4, 4)
         p=b
         i=1
         ' base background
         DO
             IF i>=&h1000 THEN EXIT DO
             p[i]=180
             i=i+2
             p[i]=255
             i=i+2
         LOOP
         p=b
         i=0
         DO
          IF i>800 THEN EXIT DO '200 800
             j=(RND*&h1000) AND &hfffc
             'j=(RND*&h400) AND &hfffc
             p[j]=72:j+=1
             p[j]=155+100*RND: j+=1
             p[j]=0: j+=1
             i+=1
         LOOP

         'MakeTex Texture(3), b, 32,32
         MakeTex Texture(3), b, 16,16
         'darker shade
         'finer tex
         FOR i=0 TO &h0fff STEP 4
             j=i
             pix(j)=pix(j)*.4: j+=1
             pix(j)=pix(j)*.54:j+=1
             pix(j)=pix(j)*.54
         NEXT
         MakeTex Texture(4), b, 16,16
         ' new detail
         REDIM as ubyte pix1(&h4000)
         dim as single f
         FOR i=0 TO &h0fff STEP 4
             FOR k=0 TO 15 STEP 4
                 j=i
                 f=RND*.4+.6:pix1(j+k+i*3)=pix(j)*f: j+=1
                 f=RND*.4+.6:pix1(j+k+i*3)=pix(j)*f: j+=1
                 f=RND*.4+.6:pix1(j+k+i*3)=pix(j)*f: j+=1
                 pix1(j+k+i*3)=pix(j) 'A
             NEXT k
         NEXT i

         MakeTex Texture(5), b, 32,32
         'MakeTex Texture(5), b, 64,64
end sub



'// The main exported plugin's function would be bbProc, like this:
FUNCTION BBProc ALIAS "BBProc" (BYREF BBP AS BBPLUGIN) AS LONG export
    

    dim as long i,j,k,l
    'default_material:
    dim as long x, y
    dim as long nRet, Msg, wParam, lParam
    static as long Mx, My, MDown,req_pick
    'STATIC UseFont AS ZGLFONT
    ' object rotation
    'static as single Cx(MAXOB),Cy(MAXOB),Cz(MAXOB)
    'static as single Px(MAXOB),Py(MAXOB),Pz(MAXOB)
    static as single inds(200)
    static as single vf(64*200) ' audio frames
    static as single  zd(64)
    static as uinteger ptr_wglSwapIntervalEXT
    static as single  atten
    static as long stt        ' rota index to land strips
    static as long  init      ' init flag enables inialisation and partial re-initialisation
    static as long  inito     ' plugin flag to indicate one initialisation has taken place
    static as long  frc       'frame count
    static as long  lmode     ' mode of landscape movement
    static as long  landsz    ' number of land strips in the landscape
    static as long  renewable ' allows new strips of lanscape to be created (modulated by fft)
    static as longint  ts1,ts2,ts3,ts4,ts5,ts6,ts7,ts8,ts9 ' for timestamps
    static as longint tt1,tt2,tt3,tt4,tt5,tt6,tt7,tt8,tt9 ' for timestamps
    static as long er1,er2,er3,er4 ' error checks
    static as long shaderA    ' shader program
    static as zstring *32 ns  ' name buffer for uniform var
    static as long ul         ' location of uniform var
    static as single fv       ' value of uniform variable
    static as long VObj,FObj  ' Vertex and Frament shader Objects
    static as single rx1,ry1,rz1 ' slow gyration
    dim as any ptr p
    static as BBPLUGIN BBC ' diagnostic capture 

    nRet = BBP_SUCCESS
    'if bbp.msg=5 then msgbox "Keyboard message received by plugin": function=nret:exit function

    SELECT CASE as const BBP.Msg

    CASE BBP_CREATE

         '// Retrieve plugin details
         'msgbox "create"
         BBP.Title    = "Soundscape GLSLf"
         BBP.Author   = "Charles Pegge"
         BBP.Version  = cvl(mkshort$(1)+mkshort$(0)) 'MAKDWD(1, 0) '// Version 1.0"
         BBP.RenderTo = BBP_OPENGL  '// or BBP_GDIPLUS, or BBP_DIRECTX

    CASE BBP_INIT

         IF inito>0 THEN EXIT FUNCTION ' allow initialisation once only
         inito=1
         '// Do your code initialisation there
         'MSGBOX "init"

         BindGLSL
         'GLSL=0 ' turn off GLSL

         shaderA=CreateShaderProg(BBP_PLUGIN_FOLDER+"Shader\shaderA.txt",VObj,Fobj)

         IF GLSL THEN
             'static  ul as long, ns as string*16, fv as single
             ns="univar"
             '//GLint glGetUniformLocation( GLuint   program, const GLchar *  name);
             p=VARPTR(ns)
             asm  push [p]
             asm  push [ShaderA]
             asm  call [glGetUniformLocation]
             asm  mov [ul],eax
         END IF


         FOR i=0 TO 64: zd(i)=RND*.3:NEXT ' vertex randomised z displacement
         BBP.RenderTo = BBP_OPENGL   '// or BBP_GDIPLUS, or BBP_DIRECTX
         wglMakeCurrent Cast(HDC,BBP.DC), Cast(HGLRC,BBP.RC)
         glClear GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT

         glClearColor 0,0,0,1
         'glGenLists 128

         'TRANSPARENT OVERLAYS
         glNewList 2, GL_COMPILE
         'glBegin GL_QUADS
         'glcolor4f 0.1,0.2,0.8,0.02
         'glvertex3f  -2,-2, 0: glvertex3f   2,-2,0
         'glvertex3f   2, 2, 0: glvertex3f  -2, 2,0
         'glend
         glBegin GL_TRIANGLE_FAN
         glcolor4f 0.1,0.2,0.8,0.02
         glvertex3f   0,  0, 0
         glcolor4f 0.1,0.2,0.8,0.005
         glvertex3f  -2, -2, 0
         glvertex3f   2, -2, 0
         glvertex3f   2,  2, 0
         glvertex3f  -2,  2, 0
         glvertex3f  -2, -2, 0
         glend
         glEndList

         glNewList 3, GL_COMPILE
         planet 5,50
         glEndList

         'STARRY BACKGOUND
         glNewList 5, GL_COMPILE
         RANDOMIZE 2468
         i=0
         glEnable GL_POINT_SMOOTH
         glPointSize 1
         glbegin GL_POINTS
         'glcolor3f 1,1,1
         'RANDOMIZE 123
         DO
             i+=1:IF i>2000 THEN EXIT DO
             IF i=1500 THEN glend: glPointSize 2: glbegin GL_POINTS
             IF i=1900 THEN glend: glPointSize 3: glbegin GL_POINTS
             IF i=1950 THEN glend: glPointSize 4: glbegin GL_POINTS
             glcolor3f  RND,RND,RND
             glvertex3f RND*120-60,RND*120-60,-100
         LOOP
         glend
         glDisable GL_POINT_SMOOTH
         glPointSize 1
         glEndList


         'MSGBOX "init"
         'render_settings:
         glShadeModel GL_SMOOTH                            'Enable Smooth Shading
         'glClearColor cl(0,0), cl(1,0), cl(2,0), cl(3,0)  'Background
         glClearDepth 1.0                                  'Depth Buffer Setup
         glEnable GL_DEPTH_TEST                            'Enables Depth Testing
         glDepthFunc GL_LEQUAL                             'The Type Of Depth Testing To Do
         glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST  'Really Nice Perspective Calculations
         'glEnable GL_LIGHTING                             'Enable Lighting
         glEnable GL_COLOR_MATERIAL                        'Enable Coloring Of Material
         glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA  'Enable Alpha Blending
         glEnable GL_BLEND                                 'Enable Blending
         glEnable GL_ALPHA_TEST                            'Enable Alpha Testing
         glAlphaFunc GL_ALWAYS,0.0                         'Set Alpha Testing
         'glDisable GL_CULL_FACE                           'Remove front or Back Face
         glEnable GL_TEXTURE_2D

         generate_textures
         '
         renewable=1
         lmode=1
         landsz=70
         atten=1
         'stt=0
         init=1
         j=landsz*64
         FOR i=0 TO j:vf(i)=0.75*RND:NEXT ' initial landscape
         FOR i=0 TO landsz: inds(i)=i:NEXT ' landscape slice index

    CASE BBP_RENDER

         '// FFT MAGIC 
         '// BBP.FFTsize returns a pointer to an area of memory containing an array of 256 singles.
         '// This is then mapped to the fft() array where it can be accessed.
         'DIM fft(BBP.FFTsize) AS SINGLE AT BBP.FFTdata
         dim as single ptr fft = Cast(single ptr,BBP.FFTdata)
         frc+=1
         IF frc=1 THEN
             TimeStamp ts1
             'IF req_pick=1 THEN
             '    static as long SelObject
             '    DIM AS LONG hits
             '    GOSUB pick_object
             '    req_pick=0
             '    'MSGBOX "pick "+str$(SelObject)+str$(hits)
             'END IF

             'GOSUB prepare_scene
             '-------------------
             dim as single ds,ds1, v,v1,v2,vk
             dim as long sts,i1,i2,newdata
             dim as vector4fv cl
             dim as vector3fv ve
             j=landsz
             i=j+2
             'static stt
             DO
                 i=i-2: IF i<0 THEN EXIT DO
                 stt=i
                 IF lmode =0 THEN inds(i)=inds(i)+0.5: IF inds(i)>j THEN inds(i)=inds(i)-j ' landscape receding
                 IF lmode=1 THEN inds(i)=inds(i)-.5: IF inds(i)<0 THEN inds(i)=inds(i)+j  ' landscape approaching
             LOOP
             i=j+2
             DO
                 i-=2: IF i<0 THEN EXIT DO
                 sts=stt:stt=stt+2: IF stt>j THEN stt=0 ' loop round  rendering front to back
                 ds=inds(stt)
                 IF (ds<0.05)AND(renewable=1) THEN
                     'audio_spectrum:
                     newdata=1
                     k=0
                     IF lmode=1 THEN i1=stt '*64
                     IF lmode=0 THEN i1=sts '*64
                     asm shl dword ptr [i1],6
                     'SHIFT LEFT i1,6
                     DO
                         IF k>=64 THEN EXIT DO
                         v=SQR( fft[k+8])*8*atten
                         IF v>2 THEN atten=2/v:v=2 ' attenuation
                         IF v=0 THEN v=RND*.4: atten=1 ' restore sensitivity
                         vf(i1)=v
                         'vf(i1)=vf(i1)*.5+SQR(fft(k))*4 ' averaged height
                         k+=1: i1+=1
                     LOOP
                 END IF
                 IF init THEN newdata=1
                 ds1=-ds ' z spacing
                 IF ds<=j THEN ' detail
                     '
                     IF newdata THEN
                         i2=sts 
                         asm shl dword ptr [i2],6 'SHIFT LEFT i2,6 ' *64
                         i1=stt
                         asm shl dword ptr [i1],6 ' SHIFT LEFT i1,6 ' *64
                         glNewList stt+16, GL_COMPILE
                         glbegin GL_QUADS
                         vk=0
                         DO
                             IF vk>62 THEN EXIT DO
                             'far left
                             v1=vk*.25
                             v=vf(i1)
                             ve.x=v1-8
                             ve.y=v
                             ve.z=zd(vk)
                             glcolor3f v,v,v
                             'void glMultiTexCoord2f( GLenum   target
                             glTexcoord2d 0,1
                             glvertex3fv  @ve.x
                             'near left
                             v=vf(i2)
                             ve.y=v
                             ve.z=ve.z+2
                             glcolor3f v,v,v
                             'void glMultiTexCoord2f( GLenum   target
                             glTexcoord2d 0,0
                             glvertex3fv  @ve.x
                             vk=vk+1
                             i1+=1
                             i2+=1
                             ' near right
                             v1=vk*.25
                             v=vf(i2)
                             ve.x=v1-8
                             ve.y=v
                             ve.z=2+zd(vk)
                             v=vf(i2)
                             ve.y=v
                             glcolor3f v,v,v
                             'void glMultiTexCoord2f( GLenum   target
                             glTexcoord2d 1,0
                             glvertex3fv  @ve.x
                             ' far right
                             v=vf(i1)
                             ve.y=v
                             ve.z=ve.z-2
                             glcolor3f v,v,v
                             'void glMultiTexCoord2f( GLenum   target
                             glTexcoord2d 1,1
                             glvertex3fv  @ve.x
                         LOOP
                         glEnd
                         glEndList
                         newdata=0
                     END IF
                 END IF
             LOOP
             init=0
             '-------------------
             ' finished preparing scene

             er1=glGetError
             TimeStamp ts2
             EXIT FUNCTION
         END IF
         IF frc>1 THEN
             frc=0
         END IF
         '
         ts5=ts6: TimeStamp ts6
         tt5=tt6: QueryPerformanceCounter cast(LARGE_INTEGER PTR, @tt6)
         TimeStamp ts3
         'GOSUB default_material
         wglMakeCurrent Cast(HDC,BBP.DC), Cast(HGLRC,BBP.RC)
         'TimeStamp ts7
         glLoadIdentity
         gluLookAt 0.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0
         glClear GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
         glClear GL_DEPTH_BUFFER_BIT
         'TimeStamp ts8

         'GOSUB render_scene
         '------------------

         '// Very important we must reassign glRC to the new glDC
         '// Note: don't use permanent DC, this produce better and smoother display


          'SLOW GYRATION
          ' FB MOD only works with integers
          rx1=(rx1+0.020): if rx1>360 then rx1-=360
          ry1=(ry1+0.022): if ry1>360 then ry1-=360
          rz1=(rz1+0.024): if rz1>360 then rz1-=360

         ' pick mode setup here
        '---------------------
        dim as RECT rct
        dim as long pickm,vv,w,c,HitDetection,SelObject,hits
        dim as long SelectBuf(1023)
        if pickm then
            'glLoadName
            '
            GetClientRect cast(HWND,BBP.ParentWindow), @rct
            SelObject=0    ' number/name of selected object
            HitDetection=1 ' flag used to indicated selection mode
            glInitNames
            glSelectBuffer 1024, @selectBuf(0)
            glRenderMode GL_SELECT
            glPushName (-1) ' an arbitrary value
            glMatrixMode GL_PROJECTION
            glLoadIdentity
            glGetIntegerv GL_VIEWPORT,cast(gluint ptr,@rct)
            gluPickMatrix  Mx, rct.bottom-My, 1.0, 1.0, cast(gluint ptr,@rct) ' single pixel selection zone
            gluPerspective 35.0, rct.right/rct.bottom, 0.1, 1500.0
            glMatrixMode GL_MODELVIEW
        end if

         glcolor3f 1,1,1

         'STARS
         glPushMatrix
         glRotatef rz1,0,0,1
         glCallList 5
         glPopMatrix


         'PLANET
         glEnable GL_TEXTURE_2D
         glBindTexture GL_TEXTURE_2D,texture(1)
         glLoadName 1
         glpushmatrix
         gltranslatef 15,12,-60
         'GOSUB gyrate_slowly
         glRotatef  rx1, 1.0, 0.0, 0.0
         glRotatef  ry1, 0.0, 1.0, 0.0
         glRotatef  rz1, 0.0, 0.0, 1.0
         '
         glCallList 3
         glpopmatrix
         glcolor3f 1,1,1
         'glEnable GL_TEXTURE_2D

         glDisable GL_TEXTURE_2D


         '--------------
         ' SOUNDSCAPE
         '--------------
         dim as long sts
         dim as single ds,ds1,v1
         glBindTexture GL_TEXTURE_2D,texture(4)
         IF GLSL THEN
             '-----------
             'asm  push GL_TEXTURE0
             'asm  call [glActiveTexture]
             'glBindTexture GL_TEXTURE_2D,texture(4)
             asm  push [shaderA]
             asm  call [glUseProgram]
             IF ul>=0 THEN
                 '//void glUniform1f(GLint location, GLfloat v0); // ,v1,v2,v3
                 fv=0.25
                 p=@fv
                 asm  push dword ptr [p]
                 asm  push [ul]
                 asm  call [glUniform1f] '2f 3f 4f
                 '-----------
                 'fv=0.6
                 '//void glGetUniformfv( GLuint   program, GLint   location,  GLfloat *  params);
                 p=@fv
                 asm  push eax
                 asm  push [ul]
                 asm  push [ShaderA]
                 asm  call [glGetUniformfv]
             END IF
         END IF

         'LOCAL ds,ds1 AS SINGLE
         'LOCAL sts,i1,i2,newdata AS LONG
         glPushMatrix
         glScalef 2.2,1.5,.5
         glRotatef 2,1,0,0
         'GOSUB gyrate_slowly
         j=landsz
         i=j+2
         DO
             i-=2: IF i<0 THEN EXIT DO
             sts=stt:stt+=2: IF stt>j THEN stt=0 ' loop round  rendering front to back
             ds=inds(stt)
             IF (GLSL=-1)AND(ul>=0) THEN
                 '//void glUniform1f(GLint location, GLfloat v0); // ,v1,v2,v3
                 fv=(j-ds)*.01
                 asm  push [fv]
                 asm  push [ul]
                 asm  call [glUniform1f] '2f 3f 4f
             END IF
             ds1=-ds ' z spacing
             IF ds<=j THEN ' detail
                 glPushMatrix
                 glTranslatef 0,-3,ds1
                 IF ds>=j-10 THEN
                  v1=(j-ds)*0.1
                  glScalef 1,v1,1
                 END IF
                 IF ds<1 THEN
                     glScalef 1,ds,1
                 END IF
                 glEnable GL_TEXTURE_2D
                 glCallList stt+16
                 glDisable GL_TEXTURE_2D
                 glPopMatrix
             END IF
         LOOP
         glPopMatrix
         i=0
         glPushMatrix
         glScalef 7,3,1
         gltranslatef 0,0.25,-20
         glPopMatrix
         IF GLSL THEN
             asm  push 0
             asm  call [glUseProgram]
         END IF
         '
         ' diffuse atmosphere
         glBegin GL_TRIANGLE_FAN
         glcolor4f 0.1,0.2,0.8,0.4
         glvertex3f  0,0,-15
         glcolor4f 0.1,0.2,0.8,0.0
         glvertex3f  -20,-1, 2
         glvertex3f   20,-1, 2
         glvertex3f   20, 6, -1
         glvertex3f  -20, 6, -1
         glvertex3f  -20,-1, 2
         glend

         ' pick mode gather data here
         if pickm then
             glPopName
             hits=cast(gluint,glRenderMode( GL_RENDER))
             HitDetection=0
             glMatrixMode GL_PROJECTION
             glLoadIdentity
             'nearest named object
             vv=&h7fffffff
             w=0
             i=0
             c=hits*4
             do
                 IF i>=c then exit do
                 IF SelectBuf(i+1)<=vv THEN vv=SelectBuf(i+1): w=SelectBuf(i+3) 'resolve by depth order
                 i=i+SelectBuf(i)+3 ' step to next
             loop
             SelObject=w
             gluPerspective 35.0, rct.right/rct.bottom, 0.1, 1500.0
             glMatrixMode GL_MODELVIEW
         end if
         glFlush


         '------------------
         ' end of scene


         er2=glGetError
         TimeStamp ts4

    CASE BBP_SIZE

         '// The size of the view port has changed.
         dim as single rAspect 
         dim as RECT rc
         GetClientRect cast(any pointer,BBP.ParentWindow), @rc

         glMatrixMode GL_PROJECTION
         glLoadIdentity
         rAspect = 1.5: IF rc.Bottom THEN rAspect = rc.Right / rc.Bottom
         gluPerspective 35.0, rAspect, 0.1, 1500.0
         glMatrixMode GL_MODELVIEW


    CASE BBP_DESTROY

         '// Free up your resources there

         IF inito=0 THEN EXIT FUNCTION

         'req_pick=0

         IF GLSL THEN
             asm  push [ShaderA]
             asm  call [glDeleteProgram]
             asm  push [VObj]
             asm  call [glDeleteShader]
             asm  push [FObj]
             asm  call [glDeleteShader]
         END IF
         er3=glGetError

         ' REPORT
         QueryPerformanceFrequency cast(LARGE_INTEGER PTR,@tt2)
         i=freefile
         OPEN "BBplugin\SoundscapeReport.txt" FOR OUTPUT AS i
         PRINT #i,"Soundscape Diagnostics"
         PRINT #i,""
         PRINT #i,"----------------------------"
         PRINT #i, "Phase 1 prepare scene: ";ts2-ts1
         PRINT #i, "Phase 2 render scene:  ";ts4-ts3
         PRINT #i, "2 Frame Interval:      ";ts6-ts5
         'PRINT #i, "wglMakeCurrent:        ";ts7-ts6
         'PRINT #i, "clear buffers etc:     ";ts8-ts7
         PRINT #i,""
         TimeStamp tt3
         QueryPerformanceCounter cast(LARGE_INTEGER PTR,@tt1)
         PRINT #i,"Frame interval rt       :   ";(tt6-tt5)/tt2
         PRINT #i,"Frame per sec rtt       :   ";tt2/(tt6-tt5)
         PRINT #i,""
         PRINT #i,"QueryPerformance Frequency: ";tt2
         PRINT #i,"-----------------------------"
         PRINT #i, "Error checks:           ";HEX$(er1),HEX$(er2),HEX$(er3)
         PRINT #i,"-----------------------------"
         PRINT #i, "GLSL:                   ";GLSL
         PRINT #i,""
         'PRINT #i, "GDIPLUS:                ";GDIPLUS
         PRINT #i, "GDIPLUS: hstatus        ";hstatus
         PRINT #i, "FREEIMAGE:              ";FREEIMAGE
         PRINT #i,"-----------------------------"
         PRINT #i,"Texture 1:               ";texture(1)
         PRINT #i,"Texture 2:               ";texture(2)
         PRINT #i,"Texture 3:               ";texture(3)
         PRINT #i,"Texture 4:               ";texture(4)
         PRINT #i,"RX1:                     ";rx1
         PRINT #i,"------------------------------"
         PRINT #i,"BBP.WinMsg:              ";hex$(BBc.WinMsg)
         PRINT #i,"BBP.wParam:              ";hex$(BBC.wParam)
         PRINT #i,"BBP.lParam:              ";hex$(BBC.lParam)
         PRINT #i,"BBP size:                ";sizeof(BBPLUGIN)
         PRINT #i,"BBP size:                ";len(BBC.title)
         PRINT #i,""
         PRINT #i, "Vertex Shader Object:   ";HEX$(VObj)
         PRINT #i, "Fragment Shader Object: ";HEX$(FObj)
         PRINT #i, "Shader program:         ";HEX$(ShaderA)
         PRINT #i, "Uniform Variable Name:  ";ns
         PRINT #i, "Uniform Variable id:    ";HEX$(ul)
         PRINT #i, "Uniform Variable Value: ";fv
         glGetIntegerv  GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS, @i
         PRINT #i, "Maximum Texture Units:  ";i
         CLOSE #i
         '
         glDeleteLists 1, 128
         glDeleteTextures 32, @texture(0)

    CASE BBP_MOUSE

         '// Handle all Windows mouse messages there
         Msg = BBP.WinMsg: wParam = BBP.wParam: lParam = BBP.lParam

         SELECT CASE as const Msg
         'CASE WM_MOUSEMOVE
         '     x = LO(WORD, lParam): y = HI(WORD, lParam)
         '     asm mov eax,[lParam]
         '     asm mov edx,eax
         '     asm and eax,&h0000ffff
         '     asm mov [Mx],eax
         '     asm shr edx,16
         '     asm mov [My],edx
         '     IF MDown = MK_LBUTTON THEN
         '        Cy(SelObject) = Cy(SelObject) + (x - Mx)
         '        Cx(SelObject) = Cx(SelObject) + (y - My)
         '        px(SelObject)=px(SelObject)+(x-Mx)*(.02-pz(SelObject)*.001)
         '        py(SelObject)=py(SelObject)+(My-y)*(.02-pz(SelObject)*.001)
         '     ELSEIF MDown = MK_RBUTTON THEN
         '        Cy(SelObject) = Cy(SelObject) + (x - Mx)
         '        Cz(SelObject) = Cz(SelObject) + (y - My)
         '        pz(SelObject)=pz(SelObject)+(y-My)*.5
         '        px(SelObject)=px(SelObject)+(x-Mx)*(.02-pz(SelObject)*.001)
         '     END IF
         '     Mx = x: My = y
         '
         CASE WM_LBUTTONDOWN, WM_RBUTTONDOWN      ', WM_MBUTTONDOWN, WM_XBUTTONDOWN

              'Mx = LO(WORD, lParam): My = HI(WORD, lParam)
              asm mov eax,[lParam]
              asm mov edx,eax
              asm and eax,&h0000ffff
              asm mov [Mx],eax
              asm shr edx,16
              asm mov [My],edx
              IF wParam = MK_LBUTTON OR wParam = MK_RBUTTON THEN MDown = wParam
              'req_pick=1 ' to perform object picking on the next render cycle
              'IF (Mx<100)AND(My<100) THEN renewable=1-renewable ' experimental control

         CASE WM_LBUTTONUP, WM_RBUTTONUP          ', WM_MBUTTONUP, WM_XBUTTONUP

              MDown = 0

         'CASE WM_LBUTTONDBLCLK, WM_RBUTTONDBLCLK ', WM_MBUTTONDBLCLK, WM_XBUTTONDBLCLK
         'CASE WM_MOUSEWHEEL
         END SELECT

    CASE BBP_KEYBOARD
BBC= BBP
        '// Handle all Windows keyboard messages there
        Msg = BBP.WinMsg: wParam = BBP.wParam: lParam = BBP.lParam
        IF (Msg=WM_KEYDOWN)OR(Msg=WM_SYSKEYDOWN) THEN
            IF wParam=&h20 THEN '
               'asm xor dword ptr [lmode],1 ' toggle
               lmode=1-lmode ' toggle
               stt=0:init=1:FOR i=0 TO landsz*64:vf(i)=0.75*RND:NEXT ' initial landscape
               FOR i=0 TO landsz: inds(i)=i:NEXT ' landscape slice index

               'FOR i=0 TO MAXOB
               '     Cx(i)=0: Cy(i)=0: Cz(i)=0 ' reset object orientation
               ' NEXT
               ' Cx(0)=15
            END IF
        END IF
        IF (Msg=WM_KEYUP)OR(Msg=WM_SYSKEYUP) THEN
         'beep
        END IF

    CASE ELSE

        nRet = BBP_ERROR

    END SELECT

    FUNCTION = nRet
end function
